﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;

namespace ComboEditorTest
{
    public partial class Form1 : Form
    {
        BLCollection collection;

        public Form1()
        {
            InitializeComponent();
            this.BackColor = Color.FromArgb(168, 167, 191);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //collection = (BLCollection)BLPerson.GetAllPersonsLight();
            //ultraComboEditor1.DataSource = collection;
        }

        private void ultraComboEditor1_Enter(object sender, EventArgs e)
        {
            UltraComboEditor comboBox = sender as Infragistics.Win.UltraWinEditors.UltraComboEditor;

            if (comboBox.Items.Count < 2)
            {
                collection = (BLCollection)BLPerson.GetAllPersonsLight();
                comboBox.DataSource = collection;
                comboBox.ValueMember = "Self";
                comboBox.DisplayMember = "Self";
                comboBox.DropDownStyle = DropDownStyle.DropDownList;
                comboBox.AutoCompleteMode = Infragistics.Win.AutoCompleteMode.SuggestAppend;
                comboBox.SelectedIndex = ultraComboEditor1.FindStringExact(comboBox.Text);
            }
        }
    }

    public class BLPerson
    {
        private int m_idProp;
        private string m_selfProp;

        public string Self
        {

            get
            {
                return m_selfProp;
            }
            set
            {
                m_selfProp = value;
            }
        }

        public int ID
        {
            get
            {
                return m_idProp;
            }

            set
            {
                m_idProp = value;
            }
        }

        public static BindingList<BLPerson> GetAllPersonsLight()
        {
            BLCollection coll = new BLCollection();
            BLPerson person; 
            person = new BLPerson();
            person.ID = 1;
            person.Self = "Jed";//
            coll.Add(person);

            person = new BLPerson();
            person.ID = 2;
            person.Self = "Sergio";
            coll.Add(person);

            person = new BLPerson();
            person.ID = 3;
            person.Self = "Stefania";
            coll.Add(person);

            person = new BLPerson();
            person.ID = 4;
            person.Self = "Michael";
            coll.Add(person);

            person = new BLPerson();
            person.ID = 5;
            person.Self = "John";
            coll.Add(person);
            return coll;
        }
    }

    public class BLCollection : BindingList<BLPerson>
    {

        public void spitThis(BLCollection bizObjectList)
        {
            StringBuilder verbage = new StringBuilder();

            foreach (BLPerson bzObj in bizObjectList)
            {
                verbage.Append(bzObj.ID.ToString());
                verbage.Append(" ");
                verbage.Append(bzObj.Self.ToString());
                verbage.Append("\n");
            }

            string mssg = verbage.ToString();
            MessageBox.Show(mssg, "Here!");
        }
    }
}
